
/*******************************************************/
/* (c) Claude Michel I3S (UNSA-CNRS) 2009,2010         */
/* Distributed under GPLv3                             */
/*******************************************************/


#ifndef _ABSTRACT_SOLVE_H
#define _ABSTRACT_SOLVE_H

#include <cudf.h>


class abstract_solver {
 public:
  virtual int init_solver(CUDFVersionedPackageList *all_versioned_packages, int other_vars) { return 0; };
  virtual int writelp(char *filename) { return 0; };
  virtual int solve() { return 0; };
  virtual double objective_value() { return 0; };
  virtual int init_solutions() { return 0; };
  virtual double get_solution(CUDFVersionedPackage *package) { return 0; };

  virtual int begin_objective(void) { return 0; };
  virtual double get_obj_coeff(CUDFVersionedPackage *package) { return 0; };
  virtual int set_obj_coeff(CUDFVersionedPackage *package, double value) { return 0; };
  virtual int set_obj_coeff(int rank, double value) { return 0; };
  virtual int end_objective(void) { return 0; };
  virtual int new_objective(void) { return 0; };
  virtual int add_objective(void) { return 0; };

  virtual int begin_add_constraints(void) { return 0; };
  virtual int new_constraint(void) { return 0; };
  virtual double get_constraint_coeff(CUDFVersionedPackage *package) { return 0; };
  virtual int set_constraint_coeff(CUDFVersionedPackage *package, double value) { return 0; };
  virtual int set_constraint_coeff(int rank, double value) { return 0; };
  virtual int add_constraint_geq(double bound) { return 0; };
  virtual int add_constraint_leq(double bound) { return 0; };
  virtual int add_constraint_eq(double bound) { return 0; };
  virtual int end_add_constraints(void) { return 0; };

  virtual ~abstract_solver() {};
  
};


#endif
