
/*******************************************************/
/* (c) Claude Michel I3S (UNSA-CNRS) 2009,2010         */
/* Distributed under GPLv3                             */
/*******************************************************/


#ifndef _CONSTRAINT_GENERATION_H_
#define _CONSTRAINT_GENERATION_H_

#include <cudf.h>
#include <abstract_solver.h>

extern bool generate_no_lp_conflict;

class an_upgrade_set {
 public:
  int nb_new_var;
  int first_var_rank;
  CUDFVersionedPackageList remove_set;
  CUDFVersionedProviderList upgrade_set;

  an_upgrade_set(int nbv, int fvr, CUDFVersionedPackageList rs, CUDFVersionedProviderList us) {
    nb_new_var = nbv;
    first_var_rank = fvr;
    remove_set = rs;
    upgrade_set = us;
  }
};

extern int new_var;
extern vector<an_upgrade_set> upgrades;


extern bool is_in_provl(const CUDFVersionedPackage *pkg, CUDFProviderList *provl);

extern bool is_in_remove(const CUDFVersionedPackage *pkg, CUDFVersionedPackageList *remove_set);

extern bool is_in_versioned_providers(const CUDFVersionedPackage *pkg, const CUDFVersion version,
				      const CUDFVersionedProviderListIterator vpbegin, 
				      const CUDFVersionedProviderListIterator vpend);


extern int preprocess_upgrade();

#define CRIT_DEFAULT 1
#define CRIT_CONSERVATIVE 2
#define CRIT_FRESHER 3
#define CRIT_SFRESHER 4
#define CRIT_FFRESHER 5
#define CRIT_TFRESHER 5
#define CRIT_PARANOID 6
#define CRIT_TRENDY   7
#define CRIT_TRENDY2  8
#define CRIT_LEXPARANOID  9
#define CRIT_LEXTRENDY   10
#define CRIT_LEXTRENDY2  11

extern int generate_constraints(abstract_solver &solver, int criteria);

#endif

