
/*******************************************************/
/* (c) Claude Michel I3S (UNSA-CNRS) 2009,2010         */
/* Distributed under GPLv3                             */
/*******************************************************/


#ifndef _LPSOLVE_SOLVER_H
#define _LPSOLVE_SOLVER_H

#include <abstract_solver.h>
#include <lp_lib.h>

class lpsolve_solver: public abstract_solver {
 public:
  int init_solver(CUDFVersionedPackageList *all_versioned_packages, int other_vars);
  int writelp(char *filename);
  int solve();
  double objective_value();
  int init_solutions();
  double get_solution(CUDFVersionedPackage *package);

  int begin_objective(void);
  double get_obj_coeff(CUDFVersionedPackage *package);
  int set_obj_coeff(CUDFVersionedPackage *package, double value);
  int set_obj_coeff(int rank, double value);
  int end_objective(void);

  int begin_add_constraints(void);
  int new_constraint(void);
  double get_constraint_coeff(CUDFVersionedPackage *package);
  int set_constraint_coeff(CUDFVersionedPackage *package, double value);
  int set_constraint_coeff(int rank, double value);
  int add_constraint_geq(double bound);
  int add_constraint_leq(double bound);
  int add_constraint_eq(double bound);
  int end_add_constraints(void);

  lprec *lp;
  CUDFVersionedPackageList *all_versioned_packages;
  int nb_packages;
  int nb_vars;

  double *coefficient;
  int *index;
  int rank;

  double *solution;

  lpsolve_solver(void) {
    lp = (lprec *)NULL;
    all_versioned_packages = (CUDFVersionedPackageList *)NULL;
    rank = 0;
    coefficient = (double *)NULL;
    index = (int *)NULL;
    solution = (double *)NULL;
  }
};

#endif
