
/*******************************************************/
/* (c) Claude Michel I3S (UNSA-CNRS) 2009,2010         */
/* Distributed under GPLv3                             */
/*******************************************************/


#ifndef _PBLIB_SOLVER_H
#define _PBLIB_SOLVER_H

#include <abstract_solver.h>

class pblib_solver: public abstract_solver {
 public:
  int init_solver(CUDFVersionedPackageList *all_versioned_packages, int other_vars);
  int writelp(char *filename);
  int solve();
  double objective_value();
  int init_solutions();
  double get_solution(CUDFVersionedPackage *package);

  int begin_objective(void);
  double get_obj_coeff(CUDFVersionedPackage *package);
  int set_obj_coeff(CUDFVersionedPackage *package, double value);
  int set_obj_coeff(int rank, double value);
  int end_objective(void);

  int begin_add_constraints(void);
  int new_constraint(void);
  double get_constraint_coeff(CUDFVersionedPackage *package);
  int set_constraint_coeff(CUDFVersionedPackage *package, double value);
  int set_constraint_coeff(int rank, double value);
  int add_constraint_geq(double bound);
  int add_constraint_leq(double bound);
  int add_constraint_eq(double bound);
  int end_add_constraints(void);

  CUDFVersionedPackageList *all_versioned_packages;
  int nb_packages;
  int nb_vars;

  double *coefficient;
  int *index;
  char **vname;
  int rank;

  int nb_constraints;
  bool usenames;
  char mult;

  double *solution;
  double objval;

  FILE *pbfile;

  char *pb_solver;

  pblib_solver(char *pb_solver) {
    this->pb_solver = pb_solver;
    nb_packages = 0;
    all_versioned_packages = (CUDFVersionedPackageList *)NULL;
    rank = 0;
    nb_constraints = 0;
    usenames = true;
    coefficient = (double *)NULL;
    index = (int *)NULL;
    vname = (char **)NULL;
    solution = (double *)NULL;
    pbfile = stdout;
    mult = ' ';
  }
};

#endif
